﻿@using dbChange.Models.VanPhongSo;
@{
    var vanban = ViewData["vanban"] as VanBan;
    var isScan = Convert.ToInt32(ViewData["isScan"]);
    var IdAccount = Convert.ToInt64(ViewData["IdAccount"]);
    var isNguoiTao = IdAccount == vanban.IdNguoiTao ? 1 : 0;
    var TrangThai = vanban.TrangThai;
}

<script type="text/javascript">
    var IdVanBan = @vanban.Id;
    var isScan = @isScan;
    var isNguoiTao = @isNguoiTao;
    var TrangThai = '@TrangThai';

    function load_danhsach_chitiet_bochungtu(){
      $.ajax({
         url: '@Url.Action("GetAllChiTietVanBan", "VanPhongSo")',
          type: 'GET',
          data: {IdVanBan:IdVanBan},
         dataType: 'json'
      })
          .done(function (response) {
              console.log(response);
            $('#gridContainer').dxDataGrid({
                dataSource: response,
                keyExpr: 'Id',
                showBorders: true,
                showRowLines: true,
                paging: {
                    enabled: false
                },
                columnAutoWidth: true,
                columnHidingEnabled: true,
                allowColumnResizing: true,
                columnFixing: {
                    enabled: true
                },
                filterRow: {
                    visible: true,
                    applyFilter: 'auto',
                },
                // filterPanel: { visible: true },
                headerFilter: { visible: true },
                columns:
                    [
                        {
                            headerCellTemplate: function(container) {
                                container.text('STT').parent().css({fontWeight: 'bold', backgroundColor: '#c5d3dd'});
                            },
                            width: 50,
                            //dataField: "STT",
                            alignment: "center",
                            cellTemplate: function (container, options) {
                              let _stt = options.rowIndex + 1;
                              $(container).html(_stt);
                            }
                        },
                        {
                            headerCellTemplate: function(container) {
                                container.text('Tiêu đề').parent().css({fontWeight: 'bold', backgroundColor: '#c5d3dd'});
                            },
                            dataField: "TieuDe",
                            //width: 200,
                            cellTemplate: function (container, options) {
                                $(container).html(options.value);
                            },
                            caption : "Tiêu đề"
                        },
                        {
                            headerCellTemplate: function(container) {
                                container.text('Nội dung').parent().css({fontWeight: 'bold', backgroundColor: '#c5d3dd'});
                            },
                            dataField: "NoiDung",
                            cellTemplate: function (container, options) {
                                $(container).html(options.value);
                            },
                            caption : "Nội dung"
                        },
                        {
                            headerCellTemplate: function(container) {
                                container.text('Đường dẫn file đã upload').parent().css({fontWeight: 'bold', backgroundColor: '#c5d3dd'});
                            },
                            dataField: "Link",
                            cellTemplate: function (container, options) {
                                $(container).html(options.value);
                            },
                            caption : "Đường dẫn file đã upload"
                        },
                        {
                            headerCellTemplate: function(container) {
                                container.text('').parent().css({fontWeight: 'bold', textAlign: 'center', backgroundColor: '#c5d3dd'});
                            },
                            width: 300,
                            //dataField: "",
                            alignment: "center",
                            cellTemplate: function (container, options) {
                                //console.log(options);
                                let text_Color_TrangThai = '<div class="btn-group2  btn-group-xs w-100">';
                                let btn_chia_se = "";
                                btn_chia_se = `
                                        <button type="button" class="btn mr-3 btn-primary rounded-pill" data-toggle="modal" data-target="#modal_ChiaSe" data-id="${options.data.Id}" data-maqr="${options.data.MaQR}" data-tieude="${options.data.TieuDe}" data-link="${options.data.LinkShare}">
                                            <i class="fa fa-share-alt"></i>Chia sẻ
                                        </button>
                                    `;
                                if (isNguoiTao) {
                                    // phieu cua minh
                                    if (isScan) {
                                        // co quyen scan
                                        if (options.data.Link != '' && options.data.Link != null) {
                                            // co up file 
                                            if (TrangThai == "HoanTat") {
                                                // trang thai hoan tat : chia se
                                                text_Color_TrangThai += `${btn_chia_se}`;
                                            } else if (TrangThai == "DaKhoa") {
                                                // trang thai da khoa : chia se, upload
                                                text_Color_TrangThai += `${btn_chia_se}`;
                                                text_Color_TrangThai += `
                                                    <button type="button" class="btn btn-secondary rounded-pill" data-toggle="modal" data-target="#modal_Upload" data-id="${options.data.Id}"  data-tieude="${options.data.TieuDe}">
                                                        <i class="fa fa-cloud-upload"></i>Upload
                                                    </button>
                                                `;
                                            }else if (TrangThai == "MoiTao") {
                                                // truong hop nay la mo khoa : xoa, upload
                                                text_Color_TrangThai += `
                                                    <button type="button" class="btn mr-3 btn-outline-danger rounded-pill action_huy_chung_tu" data-id="${options.data.Id}" data-tieude="${options.data.TieuDe}">
                                                        <i class="fa fa-trash"></i>Xóa
                                                    </button>
                                                    <button type="button" class="btn btn-secondary rounded-pill" data-toggle="modal" data-target="#modal_Upload" data-id="${options.data.Id}"  data-tieude="${options.data.TieuDe}">
                                                        <i class="fa fa-cloud-upload"></i>Upload
                                                    </button>
                                                `;
                                            }
                                        } else {
                                            // chua up file
                                            if (TrangThai == "HoanTat") {
                                                // trang thai hoan tat : khong co chuc nang
                                            } else if (TrangThai == "DaKhoa") {
                                                // trang thai da khoa : upload
                                                text_Color_TrangThai += `
                                                    <button type="button" class="btn btn-secondary rounded-pill" data-toggle="modal" data-target="#modal_Upload" data-id="${options.data.Id}"  data-tieude="${options.data.TieuDe}">
                                                        <i class="fa fa-cloud-upload"></i>Upload
                                                    </button>
                                                `;
                                            }else if (TrangThai == "MoiTao") {
                                                // truong hop nay la mo khoa : xoa, upload
                                                text_Color_TrangThai += `
                                                    <button type="button" class="btn mr-3 btn-outline-danger rounded-pill action_huy_chung_tu" data-id="${options.data.Id}" data-tieude="${options.data.TieuDe}">
                                                        <i class="fa fa-trash"></i>Xóa
                                                    </button>
                                                    <button type="button" class="btn btn-secondary rounded-pill" data-toggle="modal" data-target="#modal_Upload" data-id="${options.data.Id}"  data-tieude="${options.data.TieuDe}">
                                                        <i class="fa fa-cloud-upload"></i>Upload
                                                    </button>
                                                `;
                                            }
                                        }
                                    } else {
                                        // ko co quyen scan
                                        if (options.data.Link != '' && options.data.Link != null) {
                                            // co up file 
                                            if (TrangThai == "HoanTat") {
                                                // trang thai hoan tat : chia se
                                                text_Color_TrangThai += `${btn_chia_se}`;
                                            } else if (TrangThai == "DaKhoa") {
                                                // trang thai da khoa : chia se
                                                text_Color_TrangThai += `${btn_chia_se}`;
                                            }else if (TrangThai == "MoiTao") {
                                                // truong hop nay la mo khoa : xoa
                                                text_Color_TrangThai += `
                                                    <button type="button" class="btn mr-3 btn-outline-danger rounded-pill action_huy_chung_tu" data-id="${options.data.Id}" data-tieude="${options.data.TieuDe}">
                                                        <i class="fa fa-trash"></i>Xóa
                                                    </button>
                                                `;
                                            }
                                        } else {
                                            // chua up file
                                            if (TrangThai == "HoanTat") {
                                                // trang thai hoan tat : khong co chuc nang
                                            } else if (TrangThai == "DaKhoa") {
                                                // trang thai da khoa : khong co chuc nang
                                            }else if (TrangThai == "MoiTao") {
                                                // truong hop nay la mo khoa : xoa
                                                text_Color_TrangThai += `
                                                    <button type="button" class="btn mr-3 btn-outline-danger rounded-pill action_huy_chung_tu" data-id="${options.data.Id}" data-tieude="${options.data.TieuDe}">
                                                        <i class="fa fa-trash"></i>Xóa
                                                    </button>
                                                `;
                                            }
                                        }
                                    }
                                } else {
                                    // phieu cua ng khac
                                    if (isScan) {
                                        // co quyen scan
                                        if (options.data.Link != '' && options.data.Link != null) {
                                            // da co file
                                            if (TrangThai == "HoanTat") {
                                                // trang thai hoan tat : chia se
                                                text_Color_TrangThai += `${btn_chia_se}`;
                                            } else if (TrangThai == "DaKhoa") {
                                                // trang thai da khoa : chia se, upload
                                                text_Color_TrangThai += `${btn_chia_se}`;
                                                text_Color_TrangThai += `
                                                    <button type="button" class="btn btn-secondary rounded-pill" data-toggle="modal" data-target="#modal_Upload" data-id="${options.data.Id}"  data-tieude="${options.data.TieuDe}">
                                                        <i class="fa fa-cloud-upload"></i>Upload
                                                    </button>
                                                `;
                                            } else if (TrangThai == "MoiTao") {
                                                // truong hop nay la mo khoa : xoa, upload
                                                text_Color_TrangThai += `
                                                    <button type="button" class="btn btn-secondary rounded-pill" data-toggle="modal" data-target="#modal_Upload" data-id="${options.data.Id}"  data-tieude="${options.data.TieuDe}">
                                                        <i class="fa fa-cloud-upload"></i>Upload
                                                    </button>
                                                `;
                                            }
                                        } else {
                                            // chua co file
                                            if (TrangThai == "HoanTat") {
                                                // trang thai hoan tat : khong co chuc nang
                                            } else if (TrangThai == "DaKhoa") {
                                                // trang thai da khoa :upload
                                                text_Color_TrangThai += `
                                                    <button type="button" class="btn btn-secondary rounded-pill" data-toggle="modal" data-target="#modal_Upload" data-id="${options.data.Id}"  data-tieude="${options.data.TieuDe}">
                                                        <i class="fa fa-cloud-upload"></i>Upload
                                                    </button>
                                                `;
                                            } else if (TrangThai == "MoiTao") {
                                                // truong hop nay la mo khoa : khong co chuc nang
                                            }
                                        }
                                    } else {
                                        // ko co quyen scan
                                        if (options.data.Link != '' && options.data.Link != null) {
                                            // da co file
                                            if (TrangThai == "HoanTat") {
                                                // trang thai hoan tat : chia se
                                                text_Color_TrangThai += `${btn_chia_se}`;
                                            } else if (TrangThai == "DaKhoa") {
                                                // trang thai da khoa : chia se
                                                text_Color_TrangThai += `${btn_chia_se}`;
                                            } else if (TrangThai == "MoiTao") {
                                                // truong hop nay la mo khoa : khong co chuc nang
                                            }
                                        } else {
                                            // chua co file
                                            if (TrangThai == "HoanTat") {
                                                // trang thai hoan tat : khong co chuc nang
                                            } else if (TrangThai == "DaKhoa") {
                                                // trang thai da khoa :khong co chuc nang
                                            } else if (TrangThai == "MoiTao") {
                                                // truong hop nay la mo khoa : khong co chuc nang
                                            }
                                        }
                                    }
                                }

                                /*
                                if (options.data.Link != '' && options.data.Link != null) {
                                    btn_chia_se = `
                                        <button type="button" class="btn mr-3 btn-primary rounded-pill" data-toggle="modal" data-target="#modal_ChiaSe" data-id="${options.data.Id}" data-maqr="${options.data.MaQR}" data-tieude="${options.data.TieuDe}" data-link="${options.data.LinkShare}">
                                            <i class="fa fa-share-alt"></i>Chia sẻ
                                        </button>
                                    `;
                                    if (isScan && (TrangThai == "DaKhoa")) {
                                        text_Color_TrangThai += `
                                            <button type="button" class="btn btn-secondary rounded-pill" data-toggle="modal" data-target="#modal_Upload" data-id="${options.data.Id}"  data-tieude="${options.data.TieuDe}">
                                                <i class="fa fa-cloud-upload"></i>Upload
                                            </button>
                                    `;
                                    }
                                    else if (isScan && (TrangThai == "HoanTat")) {
                                        text_Color_TrangThai += `
                                             ${btn_chia_se}
                                        `;
                                    }
                                    if (isNguoiTao && TrangThai == "MoiTao") {
                                        text_Color_TrangThai += `
                                            <button type="button" class="btn mr-3 btn-outline-danger rounded-pill action_huy_chung_tu" data-id="${options.data.Id}" data-tieude="${options.data.TieuDe}">
                                                <i class="fa fa-trash"></i>Xóa
                                            </button>
                                    `;
                                    }
                                }
                                else {
                                    if (isScan && (TrangThai == "DaKhoa")) {
                                        text_Color_TrangThai += `
                                            <button type="button" class="btn btn-secondary rounded-pill" data-toggle="modal" data-target="#modal_Upload" data-id="${options.data.Id}"  data-tieude="${options.data.TieuDe}">
                                                <i class="fa fa-cloud-upload"></i>Upload
                                            </button>
                                    `;
                                    }else if (isScan && (TrangThai == "HoanTat")) {
                                        text_Color_TrangThai += `
                                             ${btn_chia_se}
                                    `;
                                    }
                                    if(isNguoiTao && TrangThai=="MoiTao"){
                                        text_Color_TrangThai += `
                                            <button type="button" class="btn mr-3 btn-outline-danger rounded-pill action_huy_chung_tu" data-id="${options.data.Id}" data-tieude="${options.data.TieuDe}">
                                                <i class="fa fa-trash"></i>Xoá
                                            </button>
                                    `;
                                    }
                                }
                                */
                                
                                text_Color_TrangThai += '</div>';
                                $(container).html("<h5>"+text_Color_TrangThai+"</h5>");
                            }
                        }
                    ],
                summary: {
                    totalItems:
                        [
                            {
                                column: 'MoTa',
                                summaryType: 'count',
                            }
                        ],
                }
            });
      })
      .fail(function(error) {
         console.log("error", error);
      });
    }
    load_danhsach_chitiet_bochungtu();
    $(".btnCopyLink").click(function () {
        navigator.clipboard.writeText($('.Link').val());
        $(this).html("Đã copy");
    });
    /* Chia sẽ chứng từ */
    $('#modal_ChiaSe').on('show.bs.modal', function (event) {
        $('#modal_ChiaSe .modal-body').html('');
        var button = $(event.relatedTarget);
        var _id = button.data('id');
        var _tieude = button.data('tieude');
        var _mavanban = $("#MaVanBan").val();
        var _maqr = button.data('maqr');
        var _link = button.data('link');
        var modal = $(this);
        //console.log(_id, _tieude, _maqr);
        var kq_maqr = "";
        if(_maqr){
            kq_maqr = `<img class="img-fluid" width="200" src="${_maqr}" >`;
        }else{
            kq_maqr = `<h3 class="text-danger text-center">CHƯA CÓ MÃ QR</h3>`;
        }
        var _html = `
            <h4 class="text-center mb-1"><b class="text-danger">${_mavanban}</b></h4>
            <h4 class="text-center mb-3"><b class="text-danger">${_tieude}</b></h4>
            <div class="w-100 text-center">
                ${kq_maqr}
            </div>
            <div class="w-100 text-center">
                <div class="input-group input-group-md">
                  <input type="hidden" class="form-control Link" value="${_link}" style="font-size:14px;text-align:center;color:blue" readonly/>
                </div>
            </div>
        `;
        $('#modal_ChiaSe .modal-body').html(_html);
        // $.ajax({
        //     type : 'POST',
        //     dataType : 'json',
        //     url : _url_,
        //     data : {
        //         id: _id,
        //     },
        //     success : function (res){

        //     },
        //     error : function (){
        //         alert('Có lỗi xảy ra trong quá trình xử lý');
        //     }
        //});
    });
    /* Reset Form modal classify 1*/
    $('#modal_ChiaSe').on('hide.bs.modal', function (event) {
        //$('#modal_ChiaSe .modal-content').html('');
        //alert('Đóng modal nè');
    });

    /* Huỷ chứng từ */
    $("#gridContainer").on('click', '.action_huy_chung_tu', function(e) {
        let _id = $(e.target).attr('data-id');
        let _TieuDe = $(e.target).attr('data-tieude');
        console.log(_id);
        if(_id){
            if(confirm(`Bạn muốn xóa chi tiết này?\nTiêu đề: ${_TieuDe}`)){
                $.ajax({
                    url: '@Url.Action("XoaChiTiet", "VanPhongSo")',
                    type: 'POST',
                    dataType: 'text',
                    data: { Id: _id },
                    success: function (data) {
                        if (data == "SUCCESS") {
                            load_danhsach_chitiet_bochungtu();
                            doNotify("Xóa chi tiết thành công", "success");
                        } else if (data == "ERROR_MASTER") {
                            doNotify('Xóa chi tiết không thành công do không lấy được chi tiết!', "danger");
                        } else {
                            doNotify('Xóa chi tiết không thành công do lỗi không xác định!', "danger");
                        }
                    }
                }).done(function (response) {
                            
                });
            }
        }
        // alert(message?: DOMString);
        /* Act on the event */
    });

    /* Upload */
    $('#modal_Upload').on('show.bs.modal', function (event) {
        $('#modal_Upload .modal-body').html('');
        var button = $(event.relatedTarget);
        var _id = button.data('id');
        var _tieude = button.data('tieude');
        var _maqr = button.data('maqr');
        var modal = $(this);
        //console.log(_id, _tieude, _maqr);
        var _html = "";
        if(_id){
            var _html = `
                <h4 class="text-center mb-3 text-danger">Tiêu đề: ${_tieude}</h4>
                <div class="w-100 text-center">
                    <form action="#" method="post" enctype="multipart/form-data" class="form_Upload" novalidate>
                        <div class="form-group row justify-content-md-center d-none">
                             <div class="col-6">
                                 <div class="input-group">
                                    <div class="input-group-prepend">
                                        <span class="input-group-text">Id</span>
                                    </div>
                                    <input type="text" class="form-control id" name="id" value="${_id}" readonly>
                                </div>
                            </div>
                        </div>

                        <div class="form-group row justify-content-md-center">
                            <div class="col-lg-8 col-sm-8 col-12">
                            <p style="color:red"><i>Chọn file để upload từ máy tính hoặc upload từ máy scan nếu không chọn file!</i></p>
                                <div class="input-group">
                                    <div class="col-8">
                                        <input type="file" class="form-control-file" name="file_Upload[]" id="file_Upload">
                                        <div class="invalid-feedback">Vui lòng chọn tập tin</div>
                                    </div>
    
                                    <div class="input-group-prepend">
                                        <button type="submit" class="btn btn-primary btnTaiLen">Tải lên</button>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
            `;
        }
        function sleep(ms) {
            return new Promise(resolve => setTimeout(resolve, ms));
        }
        $('#modal_Upload .modal-body').html(_html);
        var forms = document.getElementsByClassName('form_Upload');
        var validation = Array.prototype.filter.call(forms, function(form) {
            form.addEventListener('submit', async function(event) {
                if (form.checkValidity() === false) {
                    event.preventDefault();
                    event.stopPropagation();
                }else{
                    event.preventDefault();
                    $('.btnTaiLen').html("Đang xử lý, vui lòng chờ!");
                        console.log('gọi ajax');
                        var _form_data = new FormData();
                        /* Read selected files*/
                        _form_data.append('id',$(".form_Upload .id").val());
                        _form_data.append('MaVanBan',$("#MaVanBan").val());

                    var totalfiles = document.getElementById('file_Upload').files.length;
                    console.log(totalfiles);
                        for (var index = 0; index < totalfiles; index++) {
                            _form_data.append("files", document.getElementById('file_Upload').files[index]);
                        }
                        console.log(_form_data);
                    if (totalfiles > 0) {
                        $.ajax({
                            url: '@Url.Action("Upload1", "VanPhongSo")',
                            type: 'POST',
                            dataType: 'text',
                            contentType: false,
                            processData: false,
                            data: _form_data,
                            success: function (data) {
                                console.log(data);
                                if (data != "") {
                                    $("#modal_Upload").modal('hide');
                                    load_danhsach_chitiet_bochungtu();
                                    doNotify("Upload thành công", "success");
                                } else {
                                    doNotify("Upload không thành công", "danger");
                                }
                            }
                        });
                    } else {
                        console.log('begin - scanToPdfWithThumbnails');
                        scanToPdfWithThumbnails();
                        console.log('end1 - scanToPdfWithThumbnails');
                        while (imagesScanned.length <= 0) {
                             console.log('sleep');
                             await sleep(1000);
                        }
                        console.log('begin - submitFormWithScannedImages');
                        //var rs = await submitFormWithScannedImages();
                        submitFormWithScannedImages()
                            .then(function () { console.log('then'); })
                            .catch(function () { console.log('catch'); });
                        console.log('end - submitFormWithScannedImages');
                        while (isScaned == 0) {
                            console.log('sleep');
                             await sleep(1000);
                        }
                        $("#modal_Upload").modal('hide');
                        load_danhsach_chitiet_bochungtu();
                        doNotify("Upload thành công", "success");
                        
                        @*$.ajax({
                            url: '@Url.Action("Upload", "VanPhongSo")',
                            type: 'POST',
                            dataType: 'text',
                            contentType: false,
                            processData: false,
                            data: _form_data,
                            success: function (data) {
                                console.log(data);
                                if (data != "") {
                                    if (data == "ERROR") {
                                        $("#modal_Upload").modal('hide');
                                        load_danhsach_chitiet_bochungtu();
                                        doNotify("Upload không thành công", "danger");
                                    } else {
                                        $("#modal_Upload").modal('hide');
                                        load_danhsach_chitiet_bochungtu();
                                        doNotify("Upload thành công", "success");
                                    }
                                    
                                } else {
                                    doNotify("Upload không thành công", "danger");
                                }
                            }
                        });*@
                    }
                        //.done(function() {
                        //    $("#modal_Upload").modal('hide');
                        //    load_danhsach_chitiet_bochungtu();
                        //    doNotify("Upload thành công", "success");
                        //})
                        //.fail(function() {
                        //    console.log("error");
                        //})
                        //.always(function() {
                        //    console.log("complete");
                        //});

                    }
                form.classList.add('was-validated');
            }, false);
        });
    });


    (function() {
        'use strict';
        /* Valida form Thêm chứng từ chi tiết */
        window.addEventListener('load', function() {
            var forms = document.getElementsByClassName('form_Them_ChungTu_ChiTiet');
            var validation = Array.prototype.filter.call(forms, function(form) {
                form.addEventListener('submit', function(event) {
                    if (form.checkValidity() === false) {
                        event.preventDefault();
                        event.stopPropagation();
                    }else{
                        event.preventDefault();
                        console.log('gọi ajax');
                        var _form_data = new FormData();
                        /* Read selected files*/
                        _form_data.append('IdVanBan',$(".form_Them_ChungTu_ChiTiet .IdVanBan").val());
                        _form_data.append('TieuDe',$(".form_Them_ChungTu_ChiTiet .TieuDe").val());
                        _form_data.append('NoiDung',$(".form_Them_ChungTu_ChiTiet .NoiDung").val());
                        _form_data.append('MaQuyenVanBan',$(".form_Them_ChungTu_ChiTiet .MaQuyenVanBan").val());

                        /*var totalfiles = document.getElementById('file_dinh_kem').files.length;
                        for (var index = 0; index < totalfiles; index++) {
                            _form_data.append("files[]", document.getElementById('file_dinh_kem').files[index]);
                        }
                        console.log(_form_data);*/

                        $.ajax({
                            url: '@Url.Action("ThemVanBanChiTiet", "VanPhongSo")',
                            type: 'POST',
                            contentType: false,
                            processData: false,
                            data: _form_data,
                            dataType: 'text',
                            success: function (data) {
                                if (data != "") {
                                    doNotify("Thêm chi tiết thành công", "success");
                                    setTimeout(function () { window.location.reload() }, 1000);
                                } else {
                                    doNotify("Thêm chi tiết không thành công", "danger");
                                }
                            }
                        });
                    }
                    form.classList.add('was-validated');
                }, false);
            });
        }, false);

        /* Valida form Cập nhật bộ chứng từ */
        window.addEventListener('load', function() {
            var forms = document.getElementsByClassName('form_CapNhat_BoChungTu');
            var validation = Array.prototype.filter.call(forms, function(form) {
                form.addEventListener('submit', function(event) {
                    if (form.checkValidity() === false) {
                        event.preventDefault();
                        event.stopPropagation();
                    }
                    form.classList.add('was-validated');
                }, false);
            });
        }, false);
    })();

    $('.IdLoaiVanBan').select2();
    $('.btnLuuPhieu').click(function (event) {
        jQuery("#loading").fadeIn();
        var forms = document.getElementsByClassName('form_CapNhat_BoChungTu');
        var validation = Array.prototype.filter.call(forms, function(form) {
                if (form.checkValidity() === false) {
                        event.preventDefault();
                        event.stopPropagation();
                    }else{
                        event.preventDefault();
                        console.log('gọi ajax');
                        let _data = {
                                IdVanBan: $(".form_Them_ChungTu_ChiTiet .IdVanBan").val(),
                                TieuDe: $(".form_CapNhat_BoChungTu .TieuDe").val(),
                                NoiDung: $(".form_CapNhat_BoChungTu .NoiDung").val(),
                                GhiChu: $(".form_CapNhat_BoChungTu .GhiChu").val(),
                                MaQuyenVanBan: $(".form_CapNhat_BoChungTu .MaQuyenVanBan").val(),
                                IdLoaiVanBan: $(".form_CapNhat_BoChungTu .IdLoaiVanBan").val()
                        };
                        console.log(_data);

                        $.ajax({
                            url: '@Url.Action("CapNhatPhieuDangKy", "VanPhongSo")',
                            type: 'POST',
                            dataType: 'json',
                            data: _data,
                        })
                            .done(function (res) {
                                console.log(res);
                            jQuery("#loading").fadeOut();
                            doNotify("Lưu thành công", "success");
                        })
                        .fail(function() {
                            console.log("error");
                            jQuery("#loading").fadeOut();
                        })
                        .always(function() {
                            console.log("complete");
                            jQuery("#loading").fadeOut();
                        });

                    }
                    form.classList.add('was-validated');
            });
    });
    $('.btnKhoaPhieu').click(function (event) {
        jQuery("#loading").fadeIn();
        var forms = document.getElementsByClassName('form_CapNhat_BoChungTu');
        var validation = Array.prototype.filter.call(forms, function(form) {
                if (form.checkValidity() === false) {
                        event.preventDefault();
                        event.stopPropagation();
                }else{
                        event.preventDefault();
                        let _data = {
                                IdVanBan: $(".form_Them_ChungTu_ChiTiet .IdVanBan").val()
                    };
                    console.log(_data);
                    $.ajax({
                        url: '@Url.Action("KhoaPhieuDangKy", "VanPhongSo")',
                        type: 'POST',
                        dataType: 'text',
                        data: _data,
                        success: function (data) {
                            jQuery("#loading").fadeOut();
                            if (data == 'SUCCESS') {
                                doNotify("Khóa phiếu thành công", "success");
                                setTimeout(function () { window.location.reload(); }, 1000);
                            } else if (data == "ERROR_DETAIL") {
                                doNotify("Khóa phiếu không thành công do không có chi tiết!", "danger");
                            } else if (data == "ERROR_MASTER") {
                                doNotify("Khóa phiếu không thành công do không lấy được văn bản!", "danger");
                            } else {
                                doNotify("Khóa phiếu không thành công do lỗi không xác định!", "danger");
                            }
                        },
                        error: function (e) {
                            console.log(e);
                            jQuery("#loading").fadeOut();
                        }
                    });
                }
                form.classList.add('was-validated');
        });
    });
    $('.btnHoanTat').click(function (event) {
                            jQuery("#loading").fadeIn();
        var forms = document.getElementsByClassName('form_CapNhat_BoChungTu');
        var validation = Array.prototype.filter.call(forms, function(form) {
                if (form.checkValidity() === false) {
                        event.preventDefault();
                        event.stopPropagation();
                }else{
                        event.preventDefault();
                        let _data = {
                                IdVanBan: $(".form_Them_ChungTu_ChiTiet .IdVanBan").val()
                    };
                    console.log(_data);
                    $.ajax({
                        url: '@Url.Action("HoanTatPhieuDangKy", "VanPhongSo")',
                        type: 'POST',
                        dataType: 'text',
                        data: _data,
                        success: function (data) {
                            jQuery("#loading").fadeOut();
                            if (data == 'SUCCESS') {
                                doNotify("Cập nhật trạng thái phiếu thành công", "success");
                                setTimeout(function () { window.location.reload(); }, 1000);
                            } else if (data == "ERROR_DETAIL") {
                                doNotify("Cập nhật trạng thái phiếu không thành công do không có chi tiết!", "danger");
                            } else if (data == "ERROR_MASTER") {
                                doNotify("Cập nhật trạng thái phiếu không thành công do không lấy được văn bản!", "danger");
                            } else {
                                doNotify("Cập nhật trạng thái phiếu không thành công do lỗi không xác định!", "danger");
                            }
                        },
                        error: function (e) {
                            console.log(e);
                            jQuery("#loading").fadeOut();
                        }
                    });
                }
                form.classList.add('was-validated');
        });
    });
    $('.btnMoKhoaPhieu').click(function (event) {
                            jQuery("#loading").fadeIn();
        var forms = document.getElementsByClassName('form_CapNhat_BoChungTu');
        var validation = Array.prototype.filter.call(forms, function(form) {
                if (form.checkValidity() === false) {
                        event.preventDefault();
                        event.stopPropagation();
                }else{
                        event.preventDefault();
                        let _data = {
                                IdVanBan: $(".form_Them_ChungTu_ChiTiet .IdVanBan").val()
                    };
                    console.log(_data);
                    $.ajax({
                        url: '@Url.Action("MoKhoaPhieuDangKy", "VanPhongSo")',
                        type: 'POST',
                        dataType: 'text',
                        data: _data,
                        success: function (data) {
                            jQuery("#loading").fadeOut();
                            console.log(data);
                            if (data == 'SUCCESS') {
                                doNotify("Mở khóa phiếu thành công", "success");
                                setTimeout(function () { window.location.reload(); }, 1000);
                            } else if (data == "ERROR_MASTER") {
                                doNotify("Mở khóa phiếu không thành công do không lấy được văn bản!", "danger");
                            }else {
                                doNotify("Mở khóa phiếu không thành công do lỗi không xác định!", "danger");
                            }
                        },
                        error: function (e) {
                            console.log(e);
                            jQuery("#loading").fadeOut();
                        }
                    });
                }
                form.classList.add('was-validated');
        });
    });
</script>
<script type="text/javascript">
    var isScaned = 0;
        /** Scan: output PDF original and JPG thumbnails */
        function scanToPdfWithThumbnails() {
            scanner.scan(displayImagesOnPage,
                    {
                        "output_settings": [
                            {
                                "type": "return-base64",
                                "format": "jpg"
                            }
                        ]
                    }
            );
        }

        /** Processes the scan result */
        function displayImagesOnPage(successful, mesg, response) {
            if(!successful) { // On error
                console.error('Failed: ' + mesg);
                return;
            }

            if(successful && mesg != null && mesg.toLowerCase().indexOf('user cancel') >= 0) { // User cancelled.
                console.info('User cancelled');
                return;
            }

            var scannedImages = scanner.getScannedImages(response, true, false); // returns an array of ScannedImage
            for(var i = 0; (scannedImages instanceof Array) && i < scannedImages.length; i++) {
                var scannedImage = scannedImages[i];
                processOriginal(scannedImage);
            }
        }

        /** Images scanned so far. */
        var imagesScanned = [];

        /** Processes an original */
        function processOriginal(scannedImage) {
            imagesScanned.push(scannedImage);
        }



        /** Upload scanned images by submitting the form */
    async function submitFormWithScannedImages() {
       // return new Promise(function (resolve) {
             var lsImage = '';
                    for (var i = 0; i < imagesScanned.length; i++) {
                        if (i == 0) lsImage = imagesScanned[i].src;
                        else lsImage += '-' + imagesScanned[i].src;
                    }
                    var id = $(".form_Upload .id").val();
                    var MaVanBan = $("#MaVanBan").val();
                    try {
                        $.ajax({
                            url: '@Url.Action("TestUploadAPI", "VanPhongSo")',
                            type: 'POST',
                            data: { imagesScanned: lsImage, id: id, MaVanBan: MaVanBan },
                            dataType: 'json',
                            success: function (data) {
                                isScaned = 1;
                                return data;
                            }, error: function (err) {
                                isScaned = 1;
                                console.log(err);
                                return "DATRA";
                            }
                        });
                    } catch (err) {
                        console.log('loi-ajax-upload: ', err);
                                isScaned = 1;
                        return "ERROR";
                    }
         //resolve("resolve");
   // });
           
    }
</script>